/*
shuffle.c Version 0.1.0 - Fischer Random Shuffle
Copyright (C) 2004  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <frshuf.h>

FRFMT *shuffle()
   {
   int i;
   int lmt;
   int *shflptr;
   int *shflend;
   int *p,*q,*r;
   int lst[COMBOS + 16];
   int shuffle[COMBOS + 16];
   unsigned char *rndSeed;
   char *gameptr;
   char *fishptr;
   shflfmt *shuf;
   FRFMT *fischer;
   shuf = (shflfmt *) shflinit();
   if (shuf == NULL)
      {
      fprintf(stderr,"shuffle: out of memory "
	 "allocating shuf\n");
      return(NULL);
      } /* out of mem */
   shflcomb(shuf);
   rndSeed = (unsigned char *) rndinit();
   if (rndSeed == NULL)
      {
      fprintf(stderr,"shuffle: out of memory "
	 "allocating random seed\n");
      return(NULL);
      } /* out of mem */
   /* initialize lst[] */
   p = (int *) lst;
   i = 0;
   while (i < COMBOS) *p++ = i++;
   /* initialize shuffle[] */
   p = (int *) shuffle;
   q = (int *) p + COMBOS;
   while (p < q) *p++ = 0;
   /* populate shuffle[] */
   lmt = COMBOS;
   p = (int *) shuffle;
   while (lmt > 0)
      {
      i = rndnum(lmt--,rndSeed);
      q = (int *) lst + i;
      *p++ = *q;
      r = (int *) lst + lmt;
      *q = *r;
      *r = 0;
      } /* for each random combo */
   fischer = (FRFMT *) malloc(sizeof(FRFMT));
   if (fischer == NULL)
      {
      fprintf(stderr,"shuffle: out of memory "
	 "allocating random game list\n");
      return(NULL);
      } /* out of mem */
   shflptr = (int *) shuffle;
   shflend = (int *) shflptr + COMBOS;
   fishptr = (char *) fischer;
   while (shflptr < shflend)
      {
      /* copy games in random sequence */
      gameptr = (char *) shuf->game + (*shflptr << 4);
      strcpy(fishptr,gameptr);
      shflptr++;
      fishptr += WDTH;
      } /* for each random game */
   free(shuf);
   free(rndSeed);
   return(fischer);
   } /* shuffle */
